	SUBROUTINE ZGEFA (A,LDA,N,IPVT,INFO)
C
	INTEGER LDA,N,IPVT(1),INFO
        COMPLEX*16 A(LDA,1)
C
C   ZGEFA FACTORS A REAL MATRIX BY GAUSSIAN ELIMINATION
C
C  INTERNAL VARIABLES
C
	COMPLEX*16 T
        INTEGER ISAMAX,J,K,KP1,L,NM1
C
C
C    GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING
C
	INFO = 0
        NM1 = N - 1
        IF(NM1 .LT. 1) GO TO 70
        DO 60 K = 1, NM1
          KP1 = K + 1
C
C
C	FIND L = PIVOT INDEX
C
	L = ISAMAX(N-K+1, A(K,K), 1) + K - 1
        IPVT(K) = L
C
C
C
	IF(A(L,K) .EQ. (0.D0, 0.D0)) GO TO 40
C
C
C
	IF(L .EQ. K) GO TO 10
          T=A(L,K)
          A(L,K) = A(K,K)
          A(K,K) = T
   10	CONTINUE
C
C
C
	T = -1/A(K,K)
        CALL ZSCAL(N-K,T,A(K+1,K),1)
C
C
C
	DO 30 J=KP1,N
          T=A(L,J)
          IF(L .EQ. K) GO TO 20
          A(L,J) = A(K, J)
          A(K, J) = T
   20	CONTINUE
   	CALL ZAXPY(N-K, T, A(K+1,K),1,A(K+1,J),1)
   30	CONTINUE
   	GO TO 50
   40	CONTINUE
   	  INFO = K
   50	CONTINUE
   60	CONTINUE
   70	CONTINUE
   	IPVT(N) = N
        IF(A(N,N) .EQ. (0.D0, 0.D0)) INFO = N
        RETURN
        END
